# add\_pool

This entrypoint allows `admin` creating a new DEX pool.

{% hint style="info" %}
Underlying tokens should be approved (updated operators) before calling this method.
{% endhint %}

### Call parameters

<table><thead><tr><th width="158">Field</th><th width="240" align="center">Type</th><th width="448.2">Description</th></tr></thead><tbody><tr><td>a_constant</td><td align="center"><code>nat</code></td><td>"A" constant</td></tr><tr><td>input_tokens</td><td align="center"><code>set(token_t)</code></td><td>set of tokens inside the future pool (from 2 to 4 entries)</td></tr><tr><td>tokens_info</td><td align="center"><code>map(token_pool_idx_t, token_info_t)</code></td><td>map of rates config and amount of initial pool reserves </td></tr></tbody></table>

```pascaligo
type init_param_t       is [@layout:comb] record [
  a_constant              : nat;
  input_tokens            : set(token_t);
  tokens_info             : map(token_pool_idx_t, token_info_t);
]
```

{% hint style="warning" %}
This contract method is called only by `admin` of that contract.
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.quipuswap.com/smart-contracts/quipuswap-stable-swap-dex/standalone-dex/add-new-dex/add_pool.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
